from itertools import permutations


def tousLesTrajets(lesVilles, nomVilles, depart):
    trajets = list(permutations(lesVilles))
    return trajets
    
def calculDistance(trajet, lesDistances):   
    print(trajet)
    km = 0
    for i in range(len(trajet)-1):
        print(trajet[i]," ",trajet[i+1],"  ",lesDistances[trajet[i]][trajet[i+1]])
        km = km + lesDistances[trajet[i]][trajet[i+1]]
    return km

def substitution(trajet, nomVilles):
    """    
    """
    chaineTrajet = ""
    for i in trajet:
        chaineTrajet += nomVilles[i] + " "
    return chaineTrajet
    
## Programme Main    
nomVilles = ['Nancy', 'Metz', 'Paris', 'Reims', 'Troyes']
lesVilles = [0, 1, 2, 3, 4]
lesDistances = [
 [0, 55, 303, 188, 183],
 [55, 0, 306, 176, 203],
 [303, 306, 0, 142, 153],
 [188, 176, 142, 0, 123],
 [183, 203, 153, 123, 0]
 ]

#totalKm = voyageur(lesVilles, nomVilles, lesDistances, 0)
#print("\nPour une distance totale de", totalKm, 'km.')

listeTrajets = tousLesTrajets([1, 2, 3, 4], nomVilles, 0)
print(listeTrajets)
print()

depart = 0
listeCompleteTrajets = [(depart,) + trajet + (depart,) for trajet in listeTrajets ]
print(listeCompleteTrajets)

liste_resultats = []
dicoKm = {}
for trajet in listeCompleteTrajets:
    km = calculDistance(trajet, lesDistances)
    liste_resultats.append(km)
    dicoKm[trajet] = km    
    print(km)

print()
print(min(liste_resultats))

print()
print("Dictionnaire des résultats : ") 
num = 1
for key in dicoKm:
    print("Trajet : ",num, " ",substitution(key, nomVilles), " coût : ", dicoKm[key])
    num += 1
print()

# Le temps minimum
temp = min(dicoKm.values()) 
res = [key for key in dicoKm if dicoKm[key] == temp] 
for key in res:  
    print("Trajet avec le coût minimum : " + substitution(key, nomVilles) + " coût : " + str(temp) )
print()
    
# Le temps maximum
temp = max(dicoKm.values()) 
res = [key for key in dicoKm if dicoKm[key] == temp] 
for key in res:  
    print("Trajet avec le coût maximal : " + substitution(key, nomVilles) + " coût : " + str(temp) )